outtoexplore
outtoexplore

Reputation: 87

bash - Capture exit code from remote ssh command

I'm looking at capturing the exit status of a remote ssh command within a shell script I have a shell script as follows :

function rSSH {
   local x
   echo "Running ssh command"
   x=$(ssh -o StrictHostKeyChecking=no -i $keyPair -o ProxyCommand="ssh -W %h:%p -i $keyPair user@$bastionIP 22" user@$IP "$cmd")

   x=$?
   echo "SSH status is : $x"
   if [ $x -eq 0 ];then
      echo "Success"

   else
      echo "Failure"
      exit 1
   fi
}

rSSH
exit 0

When I execute the above script as a background job with an invalid $bastionIP( testing failure scenario), it results with an exit code of 0 ( instead of 1) and the only information I see in the logs is the first echo "Running ssh command" and it just exits the script.

Can someone point out what I'm doing wrong or a better way to capture the exit status of the remote ssh command. Appreciate any help.

Upvotes: 2

Views: 4039

Answers (3)

Befen
Befen

Reputation: 61

Faced the same issue. I had to execute a bunch of commands over a remote ssh connection as below and the script will terminate before the 'echo'ing the 'return here='.

ssh -v -T -i ${KEY} -p${PORT} -tt ${USER}@${IP} /bin/bash -c "'
echo "Inside Script"
exit 12
'"
echo "return here=$?"

Thanks to the response of @chepner in the original post, it was the same issue that I was using set -e

Removing it helped to resolve.

Upvotes: 3

chepner
chepner

Reputation: 530922

The script appears to be running under set -e, which means when the ssh connection fails, the script exits immediately.

Upvotes: 4

tale852150
tale852150

Reputation: 1628

Try using another variable for return code.

function rSSH {
   local x
   echo "Running ssh command"
   x=$(ssh -o StrictHostKeyChecking=no -i $keyPair -o ProxyCommand="ssh -W %h:%p -i $keyPair user@$bastionIP 22" user@$IP "$cmd")

   local ret_code
   ret_code=$?
   echo "SSH status is : $ret_code"
   if [ $ret_code -eq 0 ];then
      echo "Success"

   else
      echo "Failure"
      exit 1
   fi
}

rSSH
exit 0

Upvotes: -1

Related Questions